<HTML>
<HEAD>
<TITLE>Tree Editor - Tree Viewer</TITLE>
<link rel="StyleSheet" href="../css/main.css" type="text/css">
</HEAD>
<BODY>
<style>
.black       { background-Color:black }
.transparent { background-Color: }
.title_main {
  color: #4040FF;
  width:100%;
  height:65;
  font-size:32pt;
  font-weight:bold;
  filter:shadow(color="black", strength=10, direction=135)glow(color="black", strength=1);
}
.heading {
  color: #2020C0;
  font-weight:bold;
}
.sub_heading {
  color: #004000;
  font-weight:normal;
}
</style>

<Table cellpadding="0" cellspacing="0" BORDER="0" width="100%" HEIGHT="100%">
<TR>
<TD>

<CENTER>
<Table cellpadding="0" cellspacing="0" BORDER="0" WIDTH="95%" HEIGHT="100%">
<TR>
<TD ALIGN="LEFT" WIDTH="100%">

<CENTER>
<DIV class="title_main">Tree Editor&nbsp;</DIV>
</CENTER>

<center>
<table>
<TR>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="../graphics/thumb_old_tree.jpg" width="64" height="64" border=1></TD></TR></table>
</TD>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="../graphics/thumb_riverine.jpg" width="64" height="64" border=1></TD></TR></table>
</TD>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="../graphics/thumb_coral.jpg" width="64" height="64" border=1></TD></TR></table>
</TD>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="../graphics/thumb_tree.jpg" width="64" height="64" border=1></TD></TR></table>
</TD>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="../graphics/thumb_leaf.jpg" width="64" height="64" border=1></TD></TR></table>
</TD>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="../graphics/thumb_diagram.jpg" width="64" height="64" border=1></TD></TR></table>
</TD>

<TD>
<table cellpadding="0" cellspacing="0" border="2"><TR><TD><img src="../graphics/tree_editor.png" width="64" height="64" border=1></TD></TR></table>
</TD>

</TR></table></center>

<?php
require_once ("paths.inc.php");

$tree_root = $path_root.'lib/tree/';
include_once($tree_root."php/tree_factory.class.php");
$tree_factory = new tree_factory($tree_root);
?>

<CENTER><TABLE BORDER="0" CELLPADDING="3" WIDTH="95%">
<TR>
<TD ALIGN="LEFT" WIDTH="100%">

<H3>A collapsible heirarchical tree component.</H3>

Built using PHP, DHTML, JavaScript with persistence handled by
hidden form fields.<p>

<H3>Features</H3>

The main features that distinguish this component are:<p>

<ul>

<LI>The tree's nodes can contain <em>arbitrary</em> HTML -
and can dynamically resize themselves horizontally and
vertically;<p>

<LI>Persistence of the state of the tree when users leave
the page and return to it again is handled using hidden form
fields - and does not depend on cookies;<p>

<LI>Controls are available to collapse and expand multiple
nodes in the tree at once;<p>

<LI>Nodes of the tree are sensitive to the mouse pointer -
giving the user immediate feedback about which areas are
active.<p>

</UL>

<H3>Demonstrations</H3>

<H2>Simple tree</H2>

<?php $tree3 = $tree_factory -> web_tree(); ?>
<?php $tree3 -> collapse_all(); $tree3 -> expand_all(); ?>
<BR>
<?php $tree3 -> directory(); ?>
<a href="#">The 1.1 node</a>;

<?php $tree3 -> node(); ?>
<a href="#">The 1.2 node</a>;

<?php $tree3 -> node_last(); ?>
<a href="#">The 1.2 node</a>;

<?php $tree3 -> directory_last(); ?>
<a href="#">The 1.1 node</a>;

<?php $tree3 -> node(); ?>
<a href="#">The 1.2 node</a>;

<?php $tree3 -> node_last(); ?>
<a href="#">The 1.2 node</a>;
<?php $tree3 -> node_end(); ?>

<H2>A more complex tree - with a nested sub-tree</H2>

<?php $tree = $tree_factory -> web_tree(); ?>
<?php
  $tree -> collapse_all();
  $tree -> open_as_far_as(2);
  $tree -> open_as_far_as(3);
  $tree -> expand_all();
?>
<BR>
<?php $tree -> node(); ?>
<a href="#">The 1.1 node</a>;

<?php $tree -> node(); ?>
<a href="#">The 1.2 node</a>;

<?php $tree -> directory("first"); ?>
The first directory
<?php $tree -> close_descendants(); $tree -> open_descendants(); ?>

<?php $tree -> directory("second"); ?>
The second directory

<?php $tree -> node(); ?>
<a href="#">The 3.1 node</a>;

<?php $tree -> node_last(); ?>
<a href="#">The 3.2 node</a>;

<?php $tree -> directory("third"); ?>
The third directory
<?php $tree -> close_descendants(); $tree -> open_descendants(); ?>

<?php $tree -> node(); ?>
<a href="#">The 3.3 node</a>;

<?php $tree -> directory("fourth"); ?>
The fourth directory

<?php $tree -> node(); ?>
<a href="#">The 4.1 node</a>;

<?php $tree -> node_last(); ?>
<a href="#">The 4.2 node</a>;

<?php $tree -> directory("fifth"); ?>
The fifth directory

<?php $tree -> node(); ?>
<EM>Arbitrary</em> HTML can be placed into each section - including graphics, long lines, tall lines, and text that wraps across multiple lines;

<?php $tree -> node_last(); ?>
<table bgcolor="#C0C0C0" border="1"><tr><TD>Tables can also be used;</TD></TR></TABLE>

<?php $tree -> node_last(); ?>
<a href="#">The 3.4 node</a>;

<?php $tree -> node_last(); ?>
A nested tree:<br>

<?php $tree2 = $tree_factory -> web_tree(); ?>
<?php $tree2 -> collapse_all(); $tree2 -> expand_all(); ?>
<BR>
<?php $tree2 -> directory(); ?>
<a href="#">The 1 directory</a>;

<?php $tree2 -> node(); ?>
<a href="#">The 1.1 node</a>;

<?php $tree2 -> node_last(); ?>
<a href="#">The 1.2 node</a>;

<?php $tree2 -> directory_last(); ?>
<a href="#">The 2 directory</a>;

<?php $tree2 -> node(); ?>
<a href="#">The 2.1 node</a>;

<?php $tree2 -> node_last(); ?>
<a href="#">The 2.2 node</a>;
<?php $tree2 -> node_end(); ?>

<?php $tree -> directory_last(); ?>
<a href="#">The 2 directory</a>;

<?php $tree -> node_last(); ?>
<a href="#">The 2.1 node</a>;

<?php $tree -> node_end(); ?>

<?php $tree_factory -> finalise(); ?>


<H3>Sites using the tree component</H3>

<UL>
<LI><a href="http://treeeditor.com/">The front page of this site</a>
<LI><a href="http://texturegarden.com/">Texture Garden</a>
<LI><a href="http://cell-auto.com/">Cellular Automata</a> site
<LI><a href="http://cafaq.com/">CA FAQ</a> - and subpages
<LI><a href="http://originoflife.net/">Origin of Life site</a> - and subpages
<LI><a href="http://cr.timtyler.org/disadvantages/">CR disadvantages page</a>
<LI><a href="http://durian.timtyler.org/">Durian</a> site

</UL>

<H3>Supported browsers</H3>

The tree has been tested with Internet Explorer, Mozilla, Firefox and Opera.<P>

If there is no browser support for DHTML, JavaScript - or
whatever - the usual behaviour will be to show the tree with
all the nodes expanded.<p>

This is normally a pretty safe fall-back position - and
ensures all the content is still accessible.<p>

Not all browsers support persistence via hidden form fields.<p>

Mozilla/Firefox do not do it yet - for example.  If there is
no support for persistent form fields, then the tree's state
won't persist either.<p>


<H3>Rendering trees from a database</H3>

Code for rendering trees from an SQL database is available - but
it comes with the tree editor - and is not in the smaller
download containing just the tree component.


<H3>Rendering trees from an XML file</H3>

This code hasn't been written yet.


<H3>Source code</H3>

A zip file containing all the relevant files is available
<a href="../archive/">here</a>.<p>


<H3>License</H3>

This program and its source code have been placed into the public domain by its author.<p>


</TD></TR></TABLE></center>

<P>
<hr align=center width="25%">
<P>

<address>
<center>
<em><a href="http://timtyler.org/">Tim Tyler</a></em> |
<em><a href="http://timtyler.org/contact/">Contact</a></em> |
<em><a href="http://treeeditor.com/">http://treeeditor.com/</a></em>
</center>
</address>

</TD></TR></TABLE></center>

</body>
</html>

